/* $Id: fflow.h,v 1.6 2002/10/21 23:22:14 aa5779 Exp $ */
/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef FFLOW_H
#define FFLOW_H

#include "flow.h"
#include "util.h"

#ifndef FFLOW_IMP
extern flow_class file_flow_class;
extern flow_class *default_flow_class;
#endif

typedef struct file_flow_data
{
	int writeable;
	int preload;
	union
	{
		FILE *hfile;
		mapping *inmap;
	} x;
	char *pos;
	int buf_size;
	int undone;
} file_flow_data;

flow_handle_t ff_open(char *name, char *opts, int writeable);
void ff_close(flow_handle_t fh);
int ff_getc(flow_handle_t fh);
int ff_ungetc(flow_handle_t fh, int ch);
int ff_putc(flow_handle_t fh, int ch);
int ff_puts(flow_handle_t fh, char *str);
flow_pos_t ff_getpos(flow_handle_t fh);
int ff_setpos(flow_handle_t fh, flow_pos_t fp);
int ff_rewind(flow_handle_t fh);
char *ff_flowctl(flow_handle_t fh, char *ctl);

#endif
