/* $Id: hstream.h,v 1.7 2002/10/07 07:35:34 aa5779 Exp $ */
/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HSTREAM_H
#define HSTREAM_H

#include "interp.h"
#include "util.h"
#include "dstring.h"
#include "bstream.h"

typedef struct html_stream
{
	basic_stream basic;
	unsigned pending : 1;
	unsigned is_7bit : 1;
	unsigned pack_spaces : 1;
	unsigned allow_tags : 1;
	unsigned allow_ents : 1;
	unsigned upper_case : 1;
	html_chunk current;
} html_stream;

stream *hs_open(interpreter *i, char *name, char *fname, int writeable);
void hs_close(interpreter *i, stream *s);
html_chunk *hs_read(interpreter *i, stream *s);
void hs_writestr(interpreter *i, stream *s, char *str);
void hs_writetag(interpreter *i, stream *s, html_chunk *ch);
char *hs_ioctl(interpreter *i, stream *s, char *ctlstr);

#ifndef HSTREAM_IMP
extern stream_class html_stream_class;
#endif

#endif

